<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import SMessageForm from '../../components/messages/SMessageForm.vue'
    import { ref } from 'vue'
    import { useRouter } from 'vue-router'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { MessageApi } from '../../entities/messages/MessageApi'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { Message } from '../../entities/messages/Message'
    import { messageMapper } from '../../entities/messages/MessageMapper'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'

    const message = ref<Partial<Message>>({
        color: 'info',
    })

    const router = useRouter()
    const { getParentRoute } = useBreadcrumb()

    const msal = useMsal()

    const messageApi = new MessageApi(msal)

    async function createMessage() {
        try {
            const messageDto = messageMapper.toCreateDto(message.value)
            await messageApi.create(messageDto)

            emitSnackBar(`Message créé`, 'primary')
            router.push(getParentRoute())
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
            router.push(getParentRoute())
        }
    }
</script>

<template>
    <s-contextual-navbar page-title="Ajouter un message"></s-contextual-navbar>
    <v-main>
        <s-content-container>
            <s-message-form
                v-model="message"
                :loading="messageApi.isProcessing.value"
                @submit.prevent="createMessage()"
            >
            </s-message-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
